//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

#ifndef __DOMCHARACTERDATA_IMPL__
#define __DOMCHARACTERDATA_IMPL__

#include <CharacterData.hh>
#include "domNode_impl.hh"
#include "domString.hh"

void _iaStatus(void);

class domCharacterData_impl : public virtual _sk_CharacterData, public virtual domNode_impl
{
public:
    domCharacterData_impl();
    virtual ~domCharacterData_impl();

    virtual wstring * nodeValue(void);
    virtual void nodeValue(const wstring & _value);
    virtual wstring * data(void);
    virtual void data(const wstring & _value);
    virtual CORBA::ULong length(void);
    virtual wstring * substringData(CORBA::ULong offset ,CORBA::ULong count);
    virtual void appendData(const wstring & arg);
    virtual void insertData(CORBA::ULong offset ,const wstring & arg);
    virtual void deleteData(CORBA::ULong offset ,CORBA::ULong count);
    virtual void replaceData(CORBA::ULong offset ,CORBA::ULong count ,const wstring & arg);
protected:
    virtual CORBA::Boolean mayInsertNode(CORBA::UShort nodeType);
private:
    wchar * _textStorage;
    CORBA::ULong _textCapacity;
    CORBA::ULong _gapStart, _gapSize;
    // NOTE FYI: textLength = _textCapacity - _gapSize - 1;
};

#endif //__DOMCHARACTERDATA_IMPL__
