//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

#include "domComment_impl.hh"
#include <Node.hh>
#include "domString.hh"

CORBA::UShort domComment_impl::nodeType( void)
{
    return Node::COMMENT_NODE;
};

wstring * domComment_impl::nodeName(void)
{
    return cStringToDOMString("#comment");
}

Node_ptr domComment_impl::cloneNode(CORBA::Boolean deep)
{
    Comment_ptr newClone = new domComment_impl();
    wstring *tmpContents = nodeValue();
    newClone->nodeValue(*tmpContents);
    domStringFree(tmpContents);
    if(deep)
        deepCloneChildren(newClone);
    return newClone;
}

