//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

#include "domDocumentType_impl.hh"


domDocumentType_impl::domDocumentType_impl(const wstring & name)
{
    _dtName = domStringDup(&name);
}

domDocumentType_impl::~domDocumentType_impl(void)
{
    domStringFree(_dtName);
}

CORBA::UShort domDocumentType_impl::nodeType( void)
{
    return Node::DOCUMENT_TYPE_NODE;
};

wstring * domDocumentType_impl::nodeName( void)
{
    return domStringDup(_dtName);
};

wstring * domDocumentType_impl::nodeValue( void)
{
    return (wstring *)NULL;//Must return NULL according to DOM spec.
};

void domDocumentType_impl::nodeValue(const wstring & _value)
{
    //Must not do anything accoding to DOM spec.
};

Node_ptr domDocumentType_impl::cloneNode(CORBA :: Boolean deep)
{
    DocumentType_ptr newClone = new domDocumentType_impl(*_dtName);
    //FIXME: Remember to copy the entities and notations too, when they are implemented!
    if(deep)
        deepCloneChildren(newClone);
    return newClone;
};

CORBA::Boolean domDocumentType_impl::mayInsertNode(CORBA::UShort nodeType)
{
    if(nodeType == Node::NOTATION_NODE ||
       nodeType == Node::ENTITY_NODE)
        return 1;
    else
        return 0;
}

wstring * domDocumentType_impl::name( void)
{
    return nodeName();
};

NamedNodeMap_ptr domDocumentType_impl::entities( void)
{
    return (NamedNodeMap_ptr)NULL;//FIXME: Not implemented yet
};

NamedNodeMap_ptr domDocumentType_impl::notations( void)
{
    return (NamedNodeMap_ptr)NULL;//FIXME: Not implemented yet
};

