//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

#ifndef __DOMDOCUMENT_IMPL__
#define __DOMDOCUMENT_IMPL__

#include <Document.hh>
#include "domNode_impl.hh"
#include "domString.hh"
#include "domNodeList_impl.hh"
#include "domElement_impl.hh"
#include "domText_impl.hh"
#include "domComment_impl.hh"
#include "domProcessingInstruction_impl.hh"
#include "domAttrib_impl.hh"
#include "domCDATASection_impl.hh"
#include "domDOMImplementation_impl.hh"
#include "domDocumentFragment_impl.hh"
#include "domDocumentType_impl.hh"
#include "domEntityReference_impl.hh"

class domDocument_impl : virtual public _sk_Document, public virtual domNode_impl
{
public:
    virtual CORBA::UShort nodeType(void);
    virtual Node_ptr cloneNode(CORBA::Boolean deep);
    virtual wstring * nodeName(void);
    virtual wstring * nodeValue(void);
    virtual void nodeValue(const wstring & _value);
    
    virtual DocumentType_ptr doctype(void);
    virtual DOMImplementation_ptr implementation(void);
    virtual Element_ptr documentElement(void);
    virtual Element_ptr createElement(const wstring & tagName);
    virtual DocumentFragment_ptr createDocumentFragment(void);
    virtual Text_ptr createTextNode(const wstring & data);
    virtual Comment_ptr createComment(const wstring & data);
    virtual CDATASection_ptr createCDATASection(const wstring & data);
    virtual ProcessingInstruction_ptr createProcessingInstruction(const wstring & name ,const wstring & data);
    virtual Attrib_ptr createAttribute(const wstring & name);
    virtual EntityReference_ptr createEntityReference(const wstring & name);
    virtual NodeList_ptr getElementsByTagName(const wstring & tagname);

	//Implementation specific methods - DO NOT USE THESE!!!
    virtual ~domDocument_impl();
protected:
    virtual CORBA::Boolean mayInsertNode(CORBA::UShort nodeType);
};

#endif //__DOMDOCUMENT_IMPL__
