//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

#include "domProcessingInstruction_impl.hh"
#include "domString.hh"

domProcessingInstruction_impl::domProcessingInstruction_impl(const wstring & target)
{
    _PItarget = domStringDup(&target);
}

domProcessingInstruction_impl::~domProcessingInstruction_impl()
{
    domStringFree(_PItarget);
    domStringFree(_PIdata);
}

CORBA::UShort domProcessingInstruction_impl::nodeType(void)
{
    return Node::PROCESSING_INSTRUCTION_NODE;
}

Node_ptr domProcessingInstruction_impl::cloneNode(CORBA::Boolean deep)
{
    ProcessingInstruction_ptr newClone = new domProcessingInstruction_impl(*_PItarget);
    newClone->nodeValue(*_PIdata);
    if(deep)
        deepCloneChildren(newClone);
    return newClone;
}

wstring * domProcessingInstruction_impl::nodeName( void)
{
    return domStringDup(_PItarget);
};

wstring * domProcessingInstruction_impl::nodeValue( void)
{
    return domStringDup(_PIdata);
};

void domProcessingInstruction_impl::nodeValue(const wstring & _value)
{
    wstring *tmp_value;

    tmp_value = domStringDup(&_value);
    domStringFree(_PIdata);
    _PIdata = tmp_value;
};

CORBA::Boolean domProcessingInstruction_impl::mayInsertNode(CORBA::UShort nodeType)
{
    return 0;
}

wstring * domProcessingInstruction_impl::target( void)
{
    return nodeName();
};

wstring * domProcessingInstruction_impl::data( void)
{
    return nodeValue();
};

void domProcessingInstruction_impl::data(const wstring & _value)
{
    nodeValue(_value);
};

