//
// $id:$
//
// This source file is a part of the Berlin Project.
// Copyright (C) 1998 The Berlin Consortium 
// http://www.berlin-consortium.org
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// Author: ANOQ of the Sun
// EMail: anoq@berlin-consortium.org or anoq@vip.cybercity.dk

// Note: This is just a stripped down version of omniORB's
//       .hh file generated by omniidl2

#ifndef __Node_hh__
#define __Node_hh__

#include "CORBA.h"

#include "domDefs.hh"
#include "DOMException.hh"
#include "NodeList.hh"
#include "NamedNodeMap.hh"

#ifndef __NodeList__
#define __NodeList__
class   NodeList;
typedef NodeList* NodeList_ptr;
typedef NodeList_ptr NodeListRef;
#endif

#ifndef __NamedNodeMap__
#define __NamedNodeMap__
class   NamedNodeMap;
typedef NamedNodeMap* NamedNodeMap_ptr;
typedef NamedNodeMap_ptr NamedNodeMapRef;
#endif

#ifndef __Node__
#define __Node__
class   Node;
typedef Node* Node_ptr;
typedef Node_ptr NodeRef;
#endif

class Node : virtual public CORBA::Object
{
public:
  static const CORBA::UShort ELEMENT_NODE;
  static const CORBA::UShort ATTRIBUTE_NODE;
  static const CORBA::UShort TEXT_NODE;
  static const CORBA::UShort CDATA_SECTION_NODE;
  static const CORBA::UShort ENTITY_REFERENCE_NODE;
  static const CORBA::UShort ENTITY_NODE;
  static const CORBA::UShort PROCESSING_INSTRUCTION_NODE;
  static const CORBA::UShort COMMENT_NODE;
  static const CORBA::UShort DOCUMENT_NODE;
  static const CORBA::UShort DOCUMENT_TYPE_NODE;
  static const CORBA::UShort DOCUMENT_FRAGMENT_NODE;
  static const CORBA::UShort NOTATION_NODE;
  virtual wstring * nodeName ()  = 0;
  virtual wstring * nodeValue ()  = 0;
  virtual void nodeValue (const wstring & _value) = 0;
  virtual CORBA::UShort  nodeType ()  = 0;
  virtual Node_ptr  parentNode ()  = 0;
  virtual NodeList_ptr  childNodes ()  = 0;
  virtual Node_ptr  firstChild ()  = 0;
  virtual Node_ptr  lastChild ()  = 0;
  virtual Node_ptr  previousSibling ()  = 0;
  virtual Node_ptr  nextSibling ()  = 0;
  virtual NamedNodeMap_ptr  attributes ()  = 0;
  virtual Node_ptr  ownerDocument ()  = 0;
  virtual Node_ptr  insertBefore ( Node_ptr  newChild, Node_ptr  refChild ) = 0;
  virtual Node_ptr  replaceChild ( Node_ptr  newChild, Node_ptr  oldChild ) = 0;
  virtual Node_ptr  removeChild ( Node_ptr  oldChild ) = 0;
  virtual Node_ptr  appendChild ( Node_ptr  newChild ) = 0;
  virtual CORBA::Boolean  hasChildNodes (  ) = 0;
  virtual Node_ptr  cloneNode ( CORBA::Boolean  deep ) = 0;
  virtual void setParentNode__ ( Node_ptr  newParent ) = 0;
  virtual void setPreviousSibling__ ( Node_ptr  newPrevSib ) = 0;
  virtual void setNextSibling__ ( Node_ptr  newNextSib ) = 0;
    //static Node_ptr _duplicate(Node_ptr);
  static Node_ptr _narrow(CORBA::Object_ptr)
    { return (Node_ptr)0; }
  //static Node_ptr _nil();
protected:

  Node() {
  }
  virtual ~Node() {}
private:

  //Node(const Node&);
  //Node &operator=(const Node&);
};

class _sk_Node :  public virtual Node
{};

#endif // __Node_hh__
